﻿using EJGrid.Models;
using Microsoft.OData.Core.UriParser;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Net;
using System.Threading.Tasks;
using System.Web;
using System.Web.Http;
using System.Web.Mvc;
using System.Web.OData;
using System.Web.OData.Query;

namespace EJGrid.Controllers
{
    public class OrdersController : ODataController
    {
        // GET: Orders
        NORTHWNDEntities db = new NORTHWNDEntities();
        [EnableQuery]
        public IQueryable<Order> Get()
        {
            return db.Orders;
        }
        // PUT odata/Orders(5)
        public async Task<Order> Put(int key, Order order) //Edit operation in database
        {
            
           var entity =  await db.Orders.FindAsync(order.OrderID);
           db.Entry(entity).CurrentValues.SetValues(order);
            await db.SaveChangesAsync();
            return order;
        }
        //// POST odata/Orders
        public async Task<Order> Post(Order order) //Add Operation in database
        {
            
            db.Orders.Add(order);
            await db.SaveChangesAsync();
            return order;
        }


        //// DELETE odata/Orders(5)
        public async Task<IHttpActionResult> Delete([FromODataUri] int key)
        {
            
            var od = await db.Orders.FindAsync(key);
            if (od == null)
            {
                return NotFound();
            }

            db.Orders.Remove(od);
            await db.SaveChangesAsync();
            return StatusCode(HttpStatusCode.NoContent);
        }
    }
}